{  Dieser Ordnungsalgorithmus ist der schnellste. Er bentigt keinen
  (vor allem bei Array of string) zeitraubenden Hilfarray.
                 QuickSort
  Der - wahrscheinlich - am hufigsten verwendete Sortieralgorithmus wurde
  1960 von C.A.R.Hoare entwickelt und vorgestellt.
  Das Grundprinzip des Sortierverfahrens ist "teile und herrsche". Eine Datei
  (oder ein Array) wird einfach in zwei Teile zerlegt und schlielich in ihren
  beiden Teilen sortiert. Es wird ein Vergleichswert gewhlt, dann das Feld
  in zwei Teile zerlegt mit allen Elementen grer oder gleich dem Vergleichswert
  auf einer Seite und alle kleiner als der Vergleichswert auf der anderen Seite.
  Dieser Vorgang wird fr beide entstandenen Teile wiederholt bis die Datei sortiert ist.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BFuellen: TButton;
    BOrdnen: TButton;
    EAnzahl: TEdit;
    Label1: TLabel;
    BSchliessen: TButton;
    Memo3: TMemo;
    procedure BFuellenClick(Sender: TObject);
    procedure BOrdnenClick(Sender: TObject);
    procedure BSchliessenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tausche(var a,b:real);
  var x:real;
begin
  x:=a;
  a:=b;
  b:=x;
end;

(* Quicksort iterativ:
procedure sortieren(var aa:array of real;von,bis:integer);
   var p,i,j:integer;
begin
  p:=bis;
  while p>1 do Begin
    p:=p div 2;
    i:=von;
    repeat
      if aa[i+p]<aa[i] then BEgin
        tausche(aa[i],aa[i+p]);
        j:=i;
        while j-p>=1 do BEGin
          if aa[j]<aa[j-p] then bEgin
             tausche(aa[j],aa[j-p]);
             j:=pred(j)
          eNd  else j:=0;
        END;
      ENd;
      i:=succ(i)
    until i+p>bis
  End;
end;*)

procedure zeige(mm:Tmemo; aa:array of real);
  var i:integer;
begin
  mm.Lines.Clear;
  for i:=0 to length(aa)-1 do mm.Lines.Add(FloatToStr(aa[i]));
end;


procedure sortieren(var aa: array of real; von,bis:integer);
  //Quicksort rekursiv
  var i,j:byte;
  wertDerMitte:real;
begin
  i:=von;
  j:=bis;
  wertDerMitte:=aa[(von+bis) div 2]; //Die Mitte
  repeat
    while aa[i]<wertDerMitte do inc(i);
    while wertDerMitte<aa[j] do dec(j);
    if i<=j then Begin
      tausche(aa[i],aa[j]);
      inc(i);
      dec(j);
    End;
  until i>j;
  {Test zeige(form1.memo3,aa);
  showmessage('von='+intToStr(von)+' j='+intToStr(j)+#13+
              'i='+intToStr(i)+' bis='+intToStr(bis));}
  if von<j then sortieren(aa,von,j);
  if bis>i then sortieren(aa,i,bis);
end;

{Aufruf sortieren(aa,0,length(aa)-1)
 Beispiel: Anfang                 Nach erstem Durchlauf
           0   2                          2
           1   3                          3
           2   10                         4
           3   7                          5
           4   6<-wertDerMitte            1  alle <=6
                                    -----------
           5   8                          8  alle >=6
           6   1                          6
           7   9                          9
           8   5                          7
           9   4                         10
}
procedure TForm1.BFuellenClick(Sender: TObject);
  var i,anzahl:integer;
      aa:array of real;
begin
  anzahl:=strToInt(EAnzahl.text);
  setlength(aa,anzahl);
  memo3.Lines.Clear;
  for i:=0 to Anzahl-1 do aa[i]:=i+1;
  //Durcheinanderwirbeln
  randomize;
  for i:=0 to Anzahl-1 do tausche(aa[i],aa[random(Anzahl)]);
  zeige(memo1,aa);
end;

procedure TForm1.BOrdnenClick(Sender: TObject);
  var aa:array of real;
     n,i:integer;
begin
  n:=strToInt(EAnzahl.text);
  setlength(aa,n); //n Pltze fr aa[0] bis aa[n-1] reserviert
  for i:=0 to n-1 do aa[i]:=StrToFloat(memo1.lines[i]);
  sortieren(aa,0,length(aa)-1);
  zeige(memo3,aa);
end;

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  close
end;

end.
